%define _binaries_in_noarch_packages_terminate_build   0
%global _firmwarepath  /usr/lib/firmware
%global _xz_opts -9 --check=crc32
%global with_sof_addon 0
%global sof_ver_addon 0


Summary:        Firmware and topology files for Sound Open Firmware project
Name:           alsa-sof-firmware
Version:        2.2.6
Release:        1%{?dist}
License:        BSD
URL:            https://github.com/thesofproject/sof-bin
Source0:        %{url}/releases/download/v%{version}/sof-bin-v%{version}.tar.gz
%if 0%{?with_sof_addon}
Source1:        %{url}/releases/download/v%{sof_ver_addon}/sof-tplg-v%{sof_ver_addon}.tar.gz
%endif

BuildRequires:  alsa-topology >= 1.2.4
BuildRequires:  alsa-topology-utils >= 1.2.4

BuildArch:      noarch

%description
This package contains the firmware binaries for the Sound Open Firmware project.

%package debug
Summary:        Debug files for Sound Open Firmware project
License:        BSD
Requires:       alsa-sof-firmware

%description debug
This package contains the debug files for the Sound Open Firmware project.

%prep
%autosetup -n sof-bin-v%{version}

mkdir -p firmware/intel/sof
mv sof-v%{version}/* firmware/intel/sof
mv sof-tplg-v%{version} firmware/intel/sof-tplg

%if 0%{?with_sof_addon}
tar xvzf %{SOURCE1}
mv sof-tplg-v%{sof_ver_addon}/*.tplg firmware/intel/sof-tplg
%endif

rm LICENCE.NXP
rm -rf firmware/intel/sof-tplg/sof-imx8*
rm -rf firmware/intel/sof-tplg/sof-mt8*


find -P firmware/intel/sof -type f -name "*.ri" -exec xz -z %{_xz_opts} {} \;
for f in $(find -P firmware/intel/sof -type l -name "*.ri"); do \
  l=$(readlink "${f}"); \
  d=$(dirname "${f}"); \
  b=$(basename "${f}"); \
  rm "${f}"; \
  pushd "${d}"; \
  ln -svf "${l}.xz" "${b}.xz"; \
  popd; \
done
find -P firmware/intel/sof-tplg  -type f -name "*.tplg" -exec xz -z %{_xz_opts} {} \;

%build
alsatplg -c /usr/share/alsa/topology/hda-dsp/skl_hda_dsp_generic-tplg.conf \
         -o firmware/skl_hda_dsp_generic-tplg.bin

xz -z %{_xz_opts} firmware/*.bin
chmod 0644 firmware/*.bin.xz

%install
mkdir -p %{buildroot}%{_firmwarepath}
cp -ra firmware/* %{buildroot}%{_firmwarepath}

FILEDIR=$(pwd)

pushd %{buildroot}/%{_firmwarepath}
find -P . -name "*.ri.xz" | sed -e '/^.$/d' >> $FILEDIR/alsa-sof-firmware.files
find -P . -name "*.ldc" | sed -e '/^.$/d' > $FILEDIR/alsa-sof-firmware.debug-files
find -P . -type d | sed -e '/^.$/d' > $FILEDIR/alsa-sof-firmware.dirs
popd
sed -i -e 's:^./::' alsa-sof-firmware.{files,debug-files,dirs}
sed -i -e 's!^!/usr/lib/firmware/!' alsa-sof-firmware.{files,debug-files,dirs}
sed -e 's/^/%%dir /' alsa-sof-firmware.dirs >> alsa-sof-firmware.files
cat alsa-sof-firmware.files

%pretrans -p <lua>
path = "%{_firmwarepath}/intel/sof-tplg"
st = posix.stat(path)
if st and st.type == "link" then
  os.remove(path)
end

%files -f alsa-sof-firmware.files
%license LICENCE*
%doc README*
%dir %{_firmwarepath}
%{_firmwarepath}/*.bin.xz
%{_firmwarepath}/intel/sof-tplg/*.tplg.xz

%files debug -f alsa-sof-firmware.debug-files

%changelog
* Mon Jul 17 2023 kianli <kianli@tencent.com> - 2.2.6-1
- Upgrade to 2.2.6

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.2.4-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.2.4-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Mar 07 2023 Feng Weiyao <wynnfeng@tencent.com> - 2.2.4-1
- initial build
